#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/ioctl.h>
#include <linux/hdreg.h>
#include <string.h>
#include <errno.h>

int main(int argc, char *argv[]) {
	int fd = open("/dev/sda", O_RDONLY|O_NONBLOCK);
	if (fd < 0) {
		fprintf(stderr, "Failed to open (%s)\n", strerror(errno));
		return 1;
	}
	struct hd_driveid driveIdentity;
	int retval = ioctl(3, HDIO_GET_IDENTITY, &driveIdentity);
	if (retval < 0) {
		fprintf(stderr, "IOCTL failed (%s)\n", strerror(errno));
		return 1;
	}
	printf("Hard Disk Model: %.40s\n", driveIdentity.model);
	printf("Serial Number: %.20s\n", driveIdentity.serial_no);
	close(fd);
	return 0;
}